
set echo on

DROP PACKAGE lookup_pkg;

CREATE PACKAGE lookup_pkg AS

   FUNCTION table_lookup( 
            p_key IN lookup_table.primary_key%TYPE
            ) RETURN lookup_table.description%TYPE;

   FUNCTION array_lookup( 
            p_key IN lookup_table.primary_key%TYPE
            ) RETURN lookup_table.description%TYPE;

END lookup_pkg;
/
sho err

CREATE PACKAGE BODY lookup_pkg AS

   TYPE aat_lookup IS TABLE OF lookup_table.description%TYPE
      INDEX BY lookup_table.primary_key%TYPE;

   ga_lookups aat_lookup;

   -----------------------------------------------------------

   FUNCTION table_lookup( 
            p_key IN lookup_table.primary_key%TYPE
            ) RETURN lookup_table.description%TYPE IS

      v_return lookup_table.description%TYPE;

   BEGIN

      SELECT description INTO v_return
      FROM   lookup_table
      WHERE  primary_key = p_key;
      RETURN v_return;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         RETURN NULL;
   END table_lookup;

   -----------------------------------------------------------

   FUNCTION array_lookup( 
            p_key IN lookup_table.primary_key%TYPE
            ) RETURN lookup_table.description%TYPE IS
   BEGIN
      RETURN ga_lookups(p_key);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         RETURN NULL;
   END array_lookup;

   -----------------------------------------------------------

BEGIN

   /* Initialisation... */
   FOR r IN (SELECT primary_key, description FROM lookup_table) LOOP
      ga_lookups(r.primary_key) := r.description;
   END LOOP;

END lookup_pkg;
/

